<?php

namespace DigiComp\PhpCodesniffer\DigiComp\Sniffs;

class MemberVarUtility
{
    /**
     * Helps to find the end token of a comment, ignoring attributes, which might be in between
     *
     * @param array $tokens
     * @param array $ignore
     * @param int $stackPtr
     *
     * @return int|mixed
     */
    public static function findCommentEndWithoutAttributes(array $tokens, array $ignore, int $stackPtr)
    {
        for ($commentEnd = ($stackPtr - 1); $commentEnd >= 0; $commentEnd--) {
            if (isset($ignore[$tokens[$commentEnd]['code']]) === true) {
                continue;
            }

            if (
                $tokens[$commentEnd]['code'] === \T_ATTRIBUTE_END
                && isset($tokens[$commentEnd]['attribute_opener']) === true
            ) {
                $commentEnd = $tokens[$commentEnd]['attribute_opener'];
                continue;
            }

            break;
        }
        return $commentEnd;
    }
}
